<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:template match="/">
    <weight>
      <xsl:call-template name="weightcategory">
        <xsl:with-param name="min" select="500" />
        <xsl:with-param name="name" select="'heavy'" />
      </xsl:call-template>
      <xsl:call-template name="weightcategory">
        <xsl:with-param name="min" select="10" />
        <xsl:with-param name="max" select="500" />
        <xsl:with-param name="name" select="'medium'" />
      </xsl:call-template>
      <xsl:call-template name="weightcategory">
        <xsl:with-param name="max" select="10" />
        <xsl:with-param name="name" select="'light'" />
      </xsl:call-template>
    </weight>
  </xsl:template>

  <xsl:template name="weightcategory">
    <xsl:param name="min" select="-1" />
    <xsl:param name="max" select="-1" />
    <xsl:param name="name" />
    <xsl:element name="{$name}">
      <xsl:for-each select="distinct-values(//ShipInfo[
        ($max lt 0 or number(Freight) lt $max) and
        ($min lt 0 or number(Freight) ge $min)]/../CustomerID)">

        <customer id="{.}"/>
      </xsl:for-each>
    </xsl:element>
  </xsl:template>
</xsl:stylesheet>
